<?php

//**************************************************************************
include ("sprintpcscommon.php");

function sprintpcsdisplay($profile)
{
  global $SPRINTPREFIX;

  $today=getdate();
  
  $conf=readconfig($SPRINTPREFIX.$profile.".conf");
  $fd=fopen($SPRINTPREFIX.$profile."today.txt","r");
  $a=unserialize(fgets($fd,16384));

  $enddate=getdate($a["endtime"]);
  $startdate=getdate($a["starttime"]);
  $currentdate=getdate($a["currentasoftime"]);

  $daysincycle=$enddate["yday"]-$startdate["yday"];
  $dayssofar=$currentdate["yday"]-$startdate["yday"];

  $fraction=(time()-$a["starttime"])/($a["endtime"]-$a["starttime"]);

  preg_match("/([0-9]{3,3})([0-9]{3,3})([0-9]{4,4})/",$conf["PHONE"],$matches);
  print "<P class=sprinttitle>SprintPCS ($matches[1]-$matches[2]-$matches[3])</p>";

  print "<table cellspacing=0 border=1 width=100%>";
  print "<tr class=sprintheader><td>Type<td>Used<td>Max<td>Exp.";

  $minutes=$a["minutes"];

  // sort them so that we always show the minute groups in the same order, even if
  // sprint changes their order.
  ksort($minutes);

  foreach($minutes as $cat => $data)
    {
      $expected=intval($fraction*$data["plan"]);
      //      $expected=intval($dayssofar*$data["plan"]/$daysincycle);

      $overexp=$data["used"]-$expected;
      if ($overexp>0) 
	{
	  // how many plan minutes per second in billing cycle?
	  $x=$data["plan"]/($a["endtime"]-$a["starttime"]); 

	  // how many seconds in billing cycle would we have to use no minutes
	  // for, in order to "catch up"?
	  $x=$overexp/$x;

	  $x="<br>".intval($x/3600)." hrs ahead";
	}
      else
	{
	  $x="";
	}

      $color=sprintcomputecolor($data["used"],$data["plan"],$expected);

      print "<tr bgcolor=$color>";
      print "<td class=sprintcategory>$cat";
      print "<td class=sprintdata>$data[used]";
      print "<td class=sprintdata>$data[plan]";
      print "<td class=sprintdata>$expected $x";
    }

  print "</table>";
  
  print "<P class=sprintlegal>Current as of ".sprintformatdate($currentdate,true)."<br>";
  
  print "Cycle runs from ".sprintformatdate($startdate)." through ".sprintformatdate($enddate)."<br>";
  
  print "<a class=sprintlegal href=/sprintpcs/sprintpcsupdate.php?PROFILE=$profile&DEBUG=1>update</a></p>";

  // if the currentasofdate is more than $hoursoldwarning hours old, a warning will
  // be generated.
  $hoursoldwarning=24;

  // how old is it?
  $hoursold=intval(0.5+10*(time()-$a["updatetime"])/3600)/10.0;

  if ($hoursold>=$hoursoldwarning)
    {
      print "<br><B>WARNING: Data is $hoursold hours old!</B>";
    }

}

//**************************************************************************
function sprintcomputecolor($used,$inplan,$expected)
{
  if ($used>$expected)
    return "#ff0000";
  if ($used>=($expected*.8) && $used>0)
    return "#ffff00";
  return "#00dd00";
}

//**************************************************************************
function sprintformatdate($date,$verbose=false)
{
  $st="";

  switch ($date["mday"]%10)
    {
    case 1:
      $st=$st."st";
    break;
    case 2:
      $st=$st."nd";
    break;
    case 3:
      $st=$st."rd";
    break;
    default:
      $st=$st."th";
    }

  if (!$verbose)
    {
      $r=sprintf("%s, %s %s%s %s",$date["weekday"],$date["month"],
		 $date["mday"],$st,$date["year"]);
    }
  else
    {
      $r=sprintf("%s, %s %s%s %s at %s:%02s",$date["weekday"],$date["month"],
		 $date["mday"],$st,$date["year"],
		 $date["hours"],$date["minutes"]);
    }


  return $r;
}
?>